package com.vendor.platform.ui.internal;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.platform.api.IDeviceManager;
import com.vendor.platform.core.internal.DeviceManager;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.GroupMarker;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.action.IContributionItem;
import org.eclipse.jface.action.IMenuListener;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.internal.Workbench;
import org.eclipse.ui.internal.WorkbenchWindow;

public class MenuUtils {
  private static boolean isRunJob = false;
  
  private static Map<String, Action> actionMap = new HashMap<>();
  
  public static void setRunJob(boolean isRunJob) {
    com.vendor.platform.ui.internal.MenuUtils.isRunJob = isRunJob;
  }
  
  public static void fillDeviceList(MenuManager newMenu, IDeviceManager m) {
    newMenu.add((IContributionItem)new GroupMarker("deviceGroup"));
    String current = m.getCurrentDevice();
    List<String> devices = m.getAllDevices();
    for (String d : devices) {
      String[] split = d.split("@");
      if (split != null && split.length > 1) {
        String name = split[1];
        createDeviceMenu(newMenu, m, current, name, name);
      } 
    } 
  }
  
  private static void createDeviceMenu(MenuManager newMenu, IDeviceManager m, String current, String d, String name) {
    Object object = new Object(d, 8, m, name);
    if (name.equals(current))
      object.setChecked(true); 
    object.setId("com.vendor.device." + d);
    newMenu.appendToGroup("deviceGroup", (IAction)object);
    actionMap.put(name, object);
    newMenu.addMenuListener((IMenuListener)new Object((Action)object));
  }
  
  public static synchronized void refreshDeviceMenu() {
    IWorkbenchWindow window = Workbench.getInstance().getActiveWorkbenchWindow();
    if (window instanceof WorkbenchWindow) {
      MenuManager menuManager = ((WorkbenchWindow)window).getMenuManager();
      IContributionItem deviceItem = menuManager.find("device");
      if (deviceItem != null && deviceItem instanceof MenuManager) {
        MenuManager deviceMenu = (MenuManager)deviceItem;
        IContributionItem switchDeviceItem = deviceMenu.find("switchDevice");
        if (switchDeviceItem != null && switchDeviceItem instanceof MenuManager) {
          MenuManager switchDeviceMenu = (MenuManager)switchDeviceItem;
          switchDeviceMenu.removeAll();
          actionMap.clear();
          DeviceManager instance = (DeviceManager)DeviceManager.getInstance();
          fillDeviceList(switchDeviceMenu, (IDeviceManager)instance);
        } 
      } 
    } 
  }
}
